<?php

function image_albumupload_block($op='list', $delta=0) {

if ($op == 'list') {
    $blocks['recent_albums'] = array('info' => t('Recent uploaded albums'),
      'weight' => 0, 'status' => 1, 'region' => 'right');
      // BLOCK_CACHE_PER_ROLE will be assumed for block 0.
    return $blocks;
  }
  
else if ($op == 'view') {
    switch($delta) {
       case 0:
        $block = array('subject' => "",
          'content' => image_albumupload_view_pageblock(null, null));
	  return $block;
        break;	
    }	
}	
}

function image_albumupload_view_pageblock($item, $node){	
	if($item != null){		
		$limit = $item['limit'];
		$title = $item['title'];
	} else {
		$limit = 5;
		$title = null;
	}
	$sql = "select n.nid, u.name as username, tn.tid, tn.nid, iag.last_edit_date, td.name, n.uid, f.filepath from (select tid, last_edit_date from {image_albumupload_galleries} iag2 order by iag2.last_edit_date desc limit $limit) iag join 
	{term_data} td using (tid) join (select tn1.tid, min(tn1.nid) as nid from {term_node} tn1 group by tn1.tid) tn using (tid)
	join {node} n using (nid) join {users} u on (n.uid=u.uid) left join {files} f on (n.nid=f.nid and f.filename='thumbnail') ";		
	$result = db_query($sql);
	$galleries;
	$i=0;
	while($res = db_fetch_object($result)){
		$galleries[$i] = array(
			'uid' => $res->uid,
			'username' => $res->username,
			'last_edit_date' => $res->last_edit_date,
			'name' => $res->name,
			'tid' => $res->tid,
			'filepath' => $res->filepath
			);
		
		if($res->filepath == null){
			$galleries[$i]['filepath'] = variable_get('image_albumupload_default_preview_image','');
		}
		
		$i++;

	}	
	return theme('image_albumupload_block_recent_albums', $galleries, $node, $title);		
}


function image_albumupload_config_edit_form($delta, $stored_params){		
	$form['titlefield'] = array(
		'#type' => 'textfield',
		'#title' => t('Title'),
		'#default_value' => $stored_params['title']
	);
	
	$form['limit'] = array(
		'#type' => 'select',
		'#title' => t('Number of thumbnails'),
		'#options' => array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '10'),
		'#default_value' => $stored_params['limit'],
	);

	$form['default_picture'] = array(
		'#type' => 'textfield',
		'#title' => t('Default image'),
		'#default_value' => variable_get('image_albumupload_default_preview_image', '')
	);
	
	return $form;
}

function image_albumupload_block_submit($config_id, $form, $form_values, $submit_params){
	$stored_values['limit'] = $form_values['limit'];
	$stored_values['title'] = $form_values['titlefield'];	
	variable_set('image_albumupload_default_preview_image', $form_values['default_picture']);
	return $stored_values;
}

function image_albumupload_remove_instance_config($item){}

function theme_image_albumupload_block_recent_albums($galleries, $node, $title){
      $content.= '<div class="photoAlbumPreviewsPageBlock">';
      if($title != null){
	      $content.= '<h4>' . $title .'</h4>';	      
      }
      if($galleries == null){
	 return $content .'</div>';      
      }      
      foreach ($galleries as $gallery) {	   
	    $gallery_url = 'image/tid/' . $gallery['tid'];
	    $content.= '<div class="albumPreview">';
	    $content.= '<div class="thumbnailImage"><img src="'. file_create_url($gallery['filepath']) .'"/></div>';	
	    $content.= '<ul class="thumbnailCaption">';
	    $name = $gallery['name'];      
	    $i = strpos($name,'--');
	    if($i){
		    $name = substr($name,0, $i);
	    } 
	    $content.= '<li class="albumPreviewTitle">'.  l($name, $gallery_url)  . "</li>\n";
	    $content.= '<li class="modified">' . format_interval(time() - $gallery['last_edit_date']) . ' '.  t('ago') . '</span> '  . "</li>\n";      
	    $content.= '<li class="author">' . $gallery['username'] . "</li>\n";
	    $content.= "</ul>\n";
	    $content.= "</div>\n";
      }
      $content.= "</div>";
      return $content;
}


?>