<?php
ini_set('max_execution_time', 0);
function image_albumupload_importdirs($option = null){	
	//variable_get('file_directory_path', 'files') . variable_set('image_albumupload_dirimport_dir', $form_values['image_albumupload_dirimport_dir']);
	$path = str_replace('\\', '/', file_directory_path()) .'/' . str_replace('\\' , '/', variable_get('image_albumupload_dirimport_dir', ''));
	if(!is_dir($path)){
		return t('Directory not found:') . $path;
	}	
	$dirs = scandir($path);
	foreach($dirs as $dir){
		if(is_dir($path . '/' . $dir) &&  substr($dir, 0, 1) != '.' && substr($dir, 0, 1) != '_'){
			$real_dirs[] = $dir;				
		}
	}
	return drupal_get_form('image_albumupload_importdirs_form', $real_dirs, $path );
}

function image_albumupload_importdirs_form($dirs, $path){	
	$result = db_query('select uid,name from {users} order by name asc');
	$i=0;	
	$owner = variable_get('image_albumupload_upload_dirs_owner', 0);
	$selected_owner = 0;
	while($res = db_fetch_object($result)){
		$usernames[$i] = $res->name;
		$user_uids[$i] = $res->uid;
		if($res->uid == $owner){
			$selected_owner = $i;
		}
		$i++;
	}

	$vid = variable_get('image_gallery_nav_vocabulary', -1);
	if($vid == -1){
		drupal_set_message(t('Error: image gallery taxonomy not set. Make sure Image Gallery module is installed and goto ') . l('Image Galleries','admin/settings/image_gallery') . t(' and submit the admin form at least once.'));
		return array();
	}

	$tree = taxonomy_get_tree($vid);
	$tids;
	$i=0;
	$selected_parent = 0;
	$tid = variable_get('image_albumupload_upload_dirs_parent', 0);
	if ($tree != null && (count($tree) > 0)) {
		foreach ($tree as $term) {
			$parent_options[$i] = str_repeat('-', $term->depth) . $term->name;
			$tids[$i] = $term->tid;
			if($term->tid == $tid){
				$selected_parent = $i;
			}
			$i++;
		}
	} else if (count($tree) == 0) {
		drupal_set_message(t('Error: No taxonomy terms in Image Galleries taxonomy. Please goto ') . l(t('taxonomy'), 'admin/content/taxonomy/') . ' '. t('page and add at least one term to Image Galleries taxonomy first.'));
		return array();
	} else {
		drupal_set_message(t('Error: Image Galleries taxonomy not found. Make sure Image Galleries module is installed and the admin form is submitted at least once.'));
		return array();
	}
	
	$form['parent'] = array(
		'#type' => 'select',
		'#title' => t('Parent album'),
		'#options' => $parent_options,
		'#description' => t('Parent album where albums will be inserted. Note that if automatic year parent option is set then that gallery (possible many year galleries)  is generated 
			to this parent gallery if not already exist and albums will be inserted to that gallery.'),
		'#default_value' => $selected_parent);	
	
	$form['image_albumupload_dir_add_year_parent'] = array(
		  '#type' => 'textfield',
		  '#title' => t('Automatic year gallery'),
		  '#default_value' => variable_get('image_albumupload_dir_add_year_parent', ''),
		  '#description' => t("If not empty add images to year-gallery. Use |YEAR| to mark where 
			  year should be inserted in parent gallery name. Eg. if you put Events |YEAR| then 
			  this year (2009) galleries are inserted as child galleries to Events 2009 -gallery and if that gallery does not
			  exist then it is created. The Events 2009 parent gallery will be child gallery of the general albums parent you defined above."),
		  '#required' => FALSE,
		  );	  
 
	
	$form['owner'] = array(
		'#type' => 'select',
		'#title' => t('Owner'),
		'#options' => $usernames,
		'#default_value' => $selected_owner);	
	
	$form['date_recognizion'] = array(
		'#type' => 'select',
		'#title' => t('Date recognize'),
		'#options' => array(t('None'), 'YYYY-MM-DD_dirname', 'YYYY_MM_DD_dirname'),
		'#description' => t('Recognize date from directory name and use it as submission date. If none, then use current time.'),
		'#default_value' => variable_get('image_albumupload_upload_dirs_date_recognizion' ,0));	

	$form['append_username'] = array(
		'#type' => 'checkbox',
		'#title' => t('Append username to album name'),
		'#description' => t('Add username to album name (Albumname--username) so that albums are easy to identify in drupal taxonomy listings page. The username suffix is filtered out in theme so it does not appear on album pages to users.'),
		'#default_value' => variable_get('image_albumupload_upload_dirs_append_username' ,0));		

	$form['html'] = array(
		'#type' => 'textfield',
		'#title' => t('HTML file name'),
		'#description' => t('Extract gallery title and comment text from this html-file that is in same directory with photos'),
		'#default_value' => variable_get('image_albumupload_upload_dirs_html' ,''));		

	
	for($i=0; $i < count($dirs); $i++){
		$form['dir_' . $i] = array(
		'#type' => 'checkbox',
		'#title' => $dirs[$i],
		'#default_value' => 0);				
	}
	$form['submit'] = array('#type'=>'submit', '#value'=> t('Submit'));
	$form['#submit']['image_albumupload_importdirs_form_submit'] = array($dirs, $path, $tids, $user_uids, $usernames);
	return $form;
}

function theme_image_albumupload_importdirs_form($form){
	$str .= '<h3>' . t('Settings') . '</h3>';
	$str .= drupal_render($form['parent']);
	$str .= drupal_render($form['image_albumupload_dir_add_year_parent']);
	$str .= drupal_render($form['owner']);
	$str .= drupal_render($form['date_recognizion']);
	$str .= drupal_render($form['html']);
	$str .= drupal_render($form['append_username']);
	$str .= '<h3>' . t('Directories') . '</h3>';
	
	
	$reg_mode = variable_get('image_albumupload_upload_dirs_date_recognizion',1);
	$commentfile = variable_get('image_albumupload_upload_dirs_html', null);
	$path = file_directory_path() .'/' . str_replace('\\' , '/', variable_get('image_albumupload_dirimport_dir', ''));
	$headers = array(t('Directory'), t('Date'), t('Title'), t('Comment'));
	for($i=0; $i < count($form); $i++){
		if(isset($form['dir_'.$i])){			
			$dirname = $form['dir_'.$i]['#title'];
			$column = null;
			$column[0] = drupal_render($form['dir_'.$i]);
			$column[1] = format_date(image_albumupload_importdirs_timestr($dirname, $reg_mode), 'small');
			$column[2] = '';
			$column[3] = '';
			if($commentfile != null){
				$curfile = $path .'/'.$dirname.'/'.$commentfile;
				if(file_exists($curfile)){
						$res = image_albumupload_importdirs_parsehtml($curfile);
						$column[2] = $res['title'];
						$column[3] = $res['body'];
				}
			}
			$rows[] = $column; 
		}
	}
	$str .= theme('table', $headers, $rows);
	$str .= drupal_render($form);	
	return $str;
}

function image_albumupload_importdirs_form_submit($form, $form_values, $dirs, $path, $tids, $user_uids, $user_names){
	ini_set('max_execution_time', 0);
	if($form_values['owner'] == 0){
		drupal_set_message(t('Owner must be set'));
		return;
	}

	$owner = $user_uids[$form_values['owner']];
	variable_set('image_albumupload_upload_dirs_owner', $owner);	
	variable_set('image_albumupload_upload_dirs_date_recognizion', $form_values['date_recognizion']);
	variable_set('image_albumupload_upload_dirs_html', $form_values['html']);
	variable_set('image_albumupload_upload_dirs_append_username', $form_values['append_username']);
	
	$auto_parent = 	$form_values['image_albumupload_dir_add_year_parent'];
	variable_set('image_albumupload_dir_add_year_parent', $auto_parent);	
	$title_suffix = null;
	if($form_values['append_username'] == 1){
		$title_suffix = ' -- ' . $user_names[$form_values['owner']] ;	
	}
	$tid = $tids[$form_values['parent']];	
	variable_set('image_albumupload_upload_dirs_parent', $tid);	
	
	for($i=0; $i< count($form_values); $i++){
		if(isset($form_values['dir_' . $i]) && $form_values['dir_' . $i] == 1){
			$nmb_imported = image_albumupload_importdirs_importdir($dirs[$i], $path, $form_values['html'], $form_values['date_recognizion'], $tid, $auto_parent, $owner, $title_suffix);
			if($nmb_imported > -1){
				rename($path . '/' . $dirs[$i], $path . '/_'. $dirs[$i]);
			}
		}
	}	
	drupal_goto('image_albumupload/importdirs');
}


function image_albumupload_importdirs_timestr($str, $mode = 1){	
	if ($mode == 2){
		$str = str_replace('_', '-', $str);
	}
	$str = substr($str, 0, strlen('0000-00-00'));
	return strtotime($str);
}

function image_albumupload_importdirs_importdir($dir, $path, $commentfile, $date_options, $parent_tid, $auto_parent, $uid, $title_suffix){
	$dirpath = $path .'/' . $dir;	
	$date = time();
	if($date_options > 0){
		$date = image_albumupload_importdirs_timestr($dir, $date_options);
	} 
	
	$title = $dir;
	$comment = null;
	if($commentfile != null){
		$commentfile_path = $dirpath .'/'. $commentfile;
		if(file_exists($commentfile_path)){
			$parsed = image_albumupload_importdirs_parsehtml($commentfile_path);
			$title = $parsed['title'];
			$comment = $parsed['body'];
		}
	}
	if($title_suffix != null){
		$title .= $title_suffix;
	}		
	$vid = variable_get('image_gallery_nav_vocabulary', -1);
	if($vid == null || $vid < 0){
		drupal_set_message(t('Error creating new album') . '(' . $dir .')'. '[10034808]');	
		return -1;
	}	
	$tid = $parent_tid;	
	if(trim($auto_parent) != ''){
		$tid =  image_albumupload_create_auto_parent($tid, $vid, $date, $auto_parent);
 	}	
	//Create the gallery taxonomy terms
	if($tid == null){
		drupal_set_message(t('Error creating new album') . '(' . $dir .')'. '[22309857]');	
		return -1;	
	}
	
	$tid = image_albumupload_new_album_create_album($tid, $vid, $title, $comment, $dir, $uid, $date);
	if($tid == null || $tid <0){
		drupal_set_message(t('Error creating new album') . '(' . $dir .')'. '[10034808]');
		return -1;
	}
	
	$files = scandir($dirpath);
	$photos;
	$i;
	foreach($files as $file){
		$filepath = $dirpath . '/' . $file;
		if(is_file($filepath) && !substr($file, 0, 1) != '_'){
			$info = image_get_info($filepath);			
			$mime = $info['mime_type'];
			if(strpos(' image/jpeg image/gif image/png ', $mime)){
				$photos[$i]['filename'] = $file;
				$photos[$i]['filepath'] = $filepath;
				$i++;
			}
		}
	}
	$nmb_imported = 0;
	if($photos != null && count($photos) > 0){
		$nmb_imported = image_albumupload_importfiles($tid, $dir, $photos);
		if($nmb_imported > 0 && $date_options > 0){
			image_albumupload_change_album_owner_and_date($tid, $uid, $date);			
		}
		
	}
	return $nmb_imported;
}


function image_albumupload_importdirs_parsehtml($html_file){
	$str = file_get_contents($html_file);
	$tag = '<title>';
	$start = strpos($str, $tag);
	$title = t('Not found');
	if($start){
		$end = strpos($str, '</title>', $start);
		if($end){
			$start = $start+strlen($tag);
			$title = utf8_encode(substr($str, $start, $end-$start));
		}
	}
	$tag = '<body';
	$start = strpos($str, $tag);
	$body = t('Not found');
	if($start){
		$start = strpos($str, '>', $start);		
		$end = strpos($str, '</body>');
		if($end){
			$start = $start+1;
			$body = utf8_encode(substr($str, $start , $end-$start));
			$body = str_replace('h1', 'p', $body);
			$body = str_replace('h2', 'p', $body);
			$body = str_replace('h3', 'p', $body);
			$body = str_replace('h4', 'p', $body);
		}
	}
	return array('title' => $title,'body' => $body);	
}


?>